package eu.ruekov.ruakij.LinkedBeaconTeleporters.linkedBeaconTeleporter;

import eu.ruekov.ruakij.LinkedBeaconTeleporters.Function;
import eu.ruekov.ruakij.LinkedBeaconTeleporters.Main;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class LinkedBeaconTeleporterItem extends LinkedBeaconTeleporter {
    // INFO: Safe to store as its always cloned by bukkit
    ItemStack item;

    public LinkedBeaconTeleporterItem(){
        // Create a new LinkedBeaconTeleporter
        super();

        this.item = Main.lbtManager.getItemStackFromData(this.teleporterId);
    }
    public LinkedBeaconTeleporterItem(String teleporterId, ItemStack item) {
        super(teleporterId);

        this.item = item;
    }
    public LinkedBeaconTeleporterItem(String teleporterId){
        super(teleporterId);

        this.item = Main.lbtManager.getItemStackFromData(teleporterId);
    }

    public ItemStack item(){
        return item;
    }


    public LinkedBeaconTeleporterBlock place(BlockPlaceEvent e){
        // Deny placing when 2 LinkedBeaconTeleporter's are already placed
        if(this.linkedBeaconTeleporters.size() == 2){
            e.getPlayer().sendMessage("§cMaximum-Amount §7(2) §cof §6LinkedBeaconTeleporters §cwith id §7"+ this.teleporterId +" §care already placed");

            e.setCancelled(true);
            return null;
        }

        Block block = e.getBlock();
        Location loc = block.getLocation();

        // Block from item
        LinkedBeaconTeleporterBlock lbtBlock = new LinkedBeaconTeleporterBlock(this.teleporterId(), block);
        // Add to list
        this.linkedBeaconTeleporters.add(lbtBlock);

        // Add to id if not exists
        if(!Main.lbtManager.placedLBTsById.containsKey(this.teleporterId))
            Main.lbtManager.placedLBTsById.put(this.teleporterId, this.linkedBeaconTeleporters);

        // Add to location
        Main.lbtManager.placedLBTByLoc.put(
                Function.serialiseBlockLocation(loc),
                lbtBlock
        );

        // Notify Player when no other teleporter was found (yet?)
        if(this.linkedBeaconTeleporters.size() == 2){
            e.getPlayer().sendMessage("§6No other Teleporter found with with id §7"+ this.teleporterId);
        }
        // Notify Player when we have a full link
        else if(this.linkedBeaconTeleporters.size() == 2){
            e.getPlayer().sendMessage("§aConnected to Teleporter with id §7"+ this.teleporterId +" §e("+
                    (int)((LinkedBeaconTeleporterBlock)this.linkedBeaconTeleporters.get(0)).block.getLocation().distance(
                            ((LinkedBeaconTeleporterBlock)this.linkedBeaconTeleporters.get(1)).block().getLocation()
                    )
                    +" Blocks away)");
        }

        return lbtBlock;
    }


    // Conversion methods
    public static LinkedBeaconTeleporterItem getFromItemStack(ItemStack itemStack){
        return Main.lbtManager.getLbtItemFromItemStack(itemStack);
    }
}
